:- ensure_loaded( '../../../pe/pe' ).				%.
:- ensure_loaded( library(system) ).			
	% delete_file/1, sytem/1, make_directory/1.
:- ensure_loaded( library(lists) ).			
	% sum_list/2, append/3.
:- ensure_loaded( '../lib/render_pair_lists' ).	% /4.
:- ensure_loaded( '../lib/mean_and_emp_std_dev_list' ). 	% /3.
:- ensure_loaded( '../lib/delete_file_if' ). 	% /1.
:- ensure_loaded( '../lib/sample_that_many' ). 	% /4.
:- ensure_loaded( '../lib/unique_filename' ). 	% /2.
:- ensure_loaded( '../lib/expr_data' ). 		% /4.
:- ensure_loaded( '../lib/all_leading_digits' ). 	% /2.

fname_puts_version( Fname ) :-
	atom_codes( Fname, FnameCs ),
	reverse( FnameCs, FnRev ),
	append( Ffx, [0'/|_T1], FnRev ),
	append( _Pfx, [0'.|T2], Ffx   ),
	all_leading_digits( T2, Ldigs ),
	reverse( Ldigs, Vcs ),
	bb_put( pe_version_cs, Vcs ),
	write( bb_put( pe_version_cs, Vcs ) ), nl,
	!.

:- prolog_load_context( source, Fname ), fname_puts_version( Fname ).

pe_ppway6( [] ) :-
	delete_file_if( idatafile ),
	delete_file_if( foofoutos ),
	wake_up.

pe_ppway6( [H|T] ) :-
	!,
	write( h(H) ), nl,
	% current_output( OldOut ),
	% Call = (set_output(OldOut),pe_ppway7([H|T])),
	% (  catch(pe_exp(H),Excp,main_exc(Excp,Call)) ->
	( pe_exp(H) ->
		write( succesful_exp(H) ), nl
		;
		write( failed_exp(H) ), nl
		% pe_ppway6([H|T])
	),
	pe_ppway6( T ).

pe_exp( Id ) :-
	expr_data( Id, Runs, Dims, Titles ),
	write( expr_data( Id, Runs, Dims, Titles) ), nl,
	store_dirname( Id, Dir ),
	pe_multi( Runs, ppway6, Dir, Titles, MultiTrips ),
	% store_multi_trips( MultiTrips, Dir ),
	plot_multi_trips( MultiTrips, Dir, Dims, Titles ),
	!.

pe_main :-
	Slp = ppway6,
	DataFile = data_pw6_10k,
	delete_file( DataFile ),
	gen_data( 1000, Slp,  DataFile ),
	pe_main( Slp, DataFile, _PPs ).

pe_multi( [], _Slp, _BDir, _Dirs, [] ).
pe_multi( [Htms-Hpoints|T], Slp, BDir, [Hd|Td], [Htrip|Ttrip] ) :-
	atom_concat( 'v6_', Hd, Vhd ),
	atom_concat( BDir, Vhd, FDir ),
	atom_codes( FDir, FdCs ),
	append( FdCs, [0'/], Dir ),
	atom_codes( DirAt, Dir ),
	( file_exists( DirAt ) ->
		write( user_error, file_exists(DirAt) ),
		nl( user_error ), abort
		;
		make_directory( DirAt )
	),
	pe_iter( Hpoints, Htms, Slp, Dir, Htrip ),
	!,
	pe_multi( T, Slp, BDir, Td, Ttrip ).

pe_iter( [], _Tms, _Slp, _Dir, [] ).
pe_iter( [H|T], Tms, Slp, Dir, [H-HMean-HSD|TTrips] ) :-
	write( multi_sampling_at(H) ), nl,
	sload( Slp ),
	bb_get( pp, TruePPs ),
	kv_decompose( TruePPs, _Keys, TruePPvs ),
	pe_tms_iter( 1, Tms, H, TruePPvs, Slp, Dir, SSDs, Its, RTms ),
	store_iters_rtms( Dir, Its, RTms, H ),
	% write( mean_and_std_dev_list( SSDs, HMean, HSD ) ), nl,
	% mean_and_std_dev_list( SSDs, HMean, HSD ),
	mean_and_emp_std_dev_list( SSDs, HMean, HSD ),
	write( mean_and_emp_std_dev_list( SSDs, HMean, HSD ) ), nl,
	!,
	pe_iter( T, Tms, Slp, Dir, TTrips ).

pe_tms_iter( I, Tms, Samples, TruePPvs, Slp, Dir, Means, Its, RTms ) :-
	( I > Tms ->
		Means = [], Its = [], RTms = []
		;
		write( repetition(I)-with_ ),
		gen_data( Samples, Slp, idatafile ),
		write( gen_ ),
		% ( (Samples =:= 310,I =:=5) -> trace ; true ),
		pe_main( Slp, idatafile, PPs, It, RTm ),
		write( main_ ),
		kv_decompose( PPs, _Keys, PPvs ),
		write( dec_ ),
		render_pair_lists( TruePPvs, PPvs, square, SQList ),
		% render_pair_lists( TruePPvs, PPvs, distance, SDList ),
		write( rend_ ),
		mean_and_emp_std_dev_list( SQList, Mean, S2 ),
		store_one_iteration( Dir, Samples, I, Mean, S2 ),
		write( sum ), nl,
		Means = [Mean|TMeans],
		Its = [It|Tits],
		RTms = [RTm|RTtms],
		NxI is I + 1,
		!,
		pe_tms_iter( NxI, Tms, Samples, TruePPvs, Slp, Dir, TMeans, Tits, RTtms )
	).

pe_main( Slp, DataFile, PPs, I, Tm ) :-
	% ppway_pe_data( Data ),
	ubiquitous_metabolites( Metbls ),
	% open_null_stream( Null ),
	% current_output( OldOut ),
	% set_output( Null ),
	write( user_error, streams_ ),
	statistics( runtime, [_St1,_Ls1] ),
	% ReGoal = (set_output(OldOut),pe_main(Slp,DataFile,PPs)),
	% catch( 
			fam( [
				goal(
					[	can_produce(Metbls,_B) %,
						% can_produce([c00631,c00279],_C)
						]
						),
				slp(Slp),
				uniform(true),
				datafile(DataFile),
				count(exact),
				termin( [ll_e(1.0e-09)] ),
				return( [iter(I),termin(_Why),pp(PPs)] )
				] ),
			% Any, main_exc(Any,ReGoal) ),
	statistics( runtime, [_St2,Tm] ),
	write( user_error, took-I ), write( user_error, '_' ).
	% set_output( OldOut ).
		/* 
		write( main_iteration( I ) ), nl,
		write( main_pp( PPs ) ), nl,
		write( main_reason( Why ) ), nl.
		*/

main_exc( Exc, Goal ) :-
	write( user_error, caught(Exc) ), nl( user_error ),
	( recognised_exception( Exc ) -> 
		write( user_error, retrying(Goal) ), nl( user_error ),
		call( Goal )
		;
		write( user_error, not_retrying(Goal) ), nl( user_error ),
		halt( -1 )
	).

recognised_exception( Exc ) :-
	Exc = instantiation_error(_A,_B).
	% call( Goal ).

gen_data( ThatMany, Slp, File ) :-
	ubiquitous_metabolites( Metbls ),
	Goal = can_produce( Metbls, _Prods ),
	sample_that_many( Slp, ThatMany, Goal, Freq ),
	tell( File ),
	write( frequencies(Freq) ),
	write( '.' ), nl,
	told.
	
ppway_pe_data( 
		[	can_produce([c00631,c03356,c00279],[c00631,c03356,c00279])-103,
			can_produce([c00631,c03356,c00279],[c00009,c00944])-1805,
			can_produce([c00631,c03356,c00279],[c00009,c04691])-334,
			can_produce([c00631,c03356,c00279],[c00074,c03356,c00279])-1915,
			can_produce([c00631,c03356,c00279],[c00074,c00631,c00279])-147,
			can_produce([c00631,c03356,c00279],[c00074,c00279])-696
		] ).

ubiquitous_metabolites( [
	c00002,
	c00005,
	c00006,
	c00014,
	c00025,
	% c00064,
	c00065,
	% c00074, % only add if enz 4.2.1.1 is deleted
	c00119,
	c00279,
	c00631
	% c03356
	] ).

distance( X, Y, Z ) :-
	Z is abs( X - Y ).

square( X, Y, Z ) :-
	Z is abs( X - Y ).

% gnu_plotting.
plot_multi_trips( MultiTrips, Dir, Xxr/Yxr, Titles ) :-
	multi_trips_to_datafiles( MultiTrips, Titles, Dir, DataFiles ),
	open( gnu_com_file, write, Stream ),
	write( Stream, 'set multiplot' ), nl( Stream ),
	write( Stream, 'set xrange [0:' ),
	write( Stream, Xxr ), write( Stream, ']' ), nl( Stream ),
	write( Stream, 'set yrange [0:' ),
	write( Stream, Yxr ), write( Stream, ']' ), nl( Stream ),
	% write( Stream, 'set multiplot' ), nl( Stream ),
	write( Stream, 'plot ' ),
	datafiles_to_plot_commands( DataFiles, Titles, Stream ),
	close( Stream ),
	write( datafiles(DataFiles) ), nl,
	write( gnufile(gnu_com_file) ), nl,
	% Titles = [Hti|_Tti],
	% atom_concat( Hti, '/', HtiSl ),
	% atom_concat( HtiSl, 'colour.eps', Colour ),
	% atom_concat( HtiSl, 'mono.eps', Mono  ),
	set_gnu_eps_file_output( gnu_com_file, Dir, colour, gnu_com_file_col ),
	system( 'gnuplot \"gnu_com_file_col\"'),
	set_gnu_eps_file_output( gnu_com_file, Dir, mono, gnu_com_file_mono ),
	system( 'gnuplot -mono \"gnu_com_file_mono\"'),
	atom_concat( 'mv gnu_com_file* ',Dir, Mv ),
	system( Mv ).

multi_trips_to_datafiles( [], _Empty, _DirSl, [] ).
multi_trips_to_datafiles( [H|T], [Httl|TTtl], DirSl, [Hdf|Tdf] ) :-
	datafile_name( DirSl, Httl, Hdf ),
	trips_to_datafile( Hdf, H ),
	multi_trips_to_datafiles( T, TTtl, DirSl, Tdf ).

datafile_name( DirSl, FName, Dfln ) :-
	( file_exists( DirSl ) -> 
		true
		;
		% atom_concat( 'mkdir ', Dir, MkDir ),
		% mkdir( MkDir )
		make_directory( DirSl )
	),
	atom_concat( DirSl, FName, DfDir ),
	atom_concat( DfDir, '.dat', Dfln ).

trips_to_datafile( File, Trips ) :-
	open( File, write, Stream ), 
	trips_to_stream( Trips, Stream ),
	close( Stream ).

trips_to_stream( [], _Stream ).
trips_to_stream( [X-Y-Yd|T], Stream ) :-
	write( Stream, X ), write( Stream, ' ' ), 
	write( Stream, Y ), write( Stream, ' ' ),
	write( Stream, Yd), nl( Stream ),
	trips_to_stream( T, Stream ).

datafiles_to_plot_commands( [], _Empty, _Stream ).
datafiles_to_plot_commands( [H|T], [Hti|Tti], Stream ) :-
	%  write( Stream, Hti ),
	write( Stream, ' \"' ), write( Stream, H ), 
	write( Stream, '\" using 1:2 ' ),
		write( Stream, ' title \"' ),
		write( Stream, Hti ), 
		write( Stream, '\"' ),
		write( Stream, ' with lines, ' ),
	write( Stream, '"' ), write( Stream, H ), 
	write( Stream, '\" notitle with yerrorbars' ),
	( T = [] ->
		true
		;
		write( Stream, ',' )
	),
	datafiles_to_plot_commands( T, Tti, Stream ).

set_gnu_eps_file_output( SkelCF, BaseDirSl, ColOr, FullCF ) :-
	open( FullCF, write, Wstream ),
	write( Wstream, 'set terminal postscript eps ' ),
	write( Wstream, ColOr ), nl( Wstream ),
	write( Wstream, 'set output \"' ),
	write( Wstream, BaseDirSl ), % write( Wstream, '/' ),
	write( Wstream, ColOr ), write( Wstream, '.eps' ),
	write( Wstream, '\"' ),
	nl( Wstream ),
	close( Wstream ),
	atom_concat( 'cat ', SkelCF, Pfx1 ),
	atom_concat( Pfx1, ' >> ', Pfx2 ),
	atom_concat( Pfx2, FullCF, Cat ),
	system( Cat ).

/* 
store_multi_trips( MultiTrips, Dir ) :-
	( file_exists( Dir ) ->
		true
		;
		make_directory( Dir )
	),
	atom_concat( Dir, '/multi_trips', File ),
	open( File, write, Stream ),
	write( Stream, multi_trips(MultiTrips) ),
	write( Stream, '.' ),
	close( Stream ). */

wake_up :-
	put( 7 ).

store_dirname( Id, DirName ) :-
	% bb_get( pe_version_cs, Vcs ),
	% append( Vcs, "_", First ),
	% atom_codes( Id, IdCs ),
	% append( First, IdCs, DirNameCs ),
	atom_codes( Id, DirNameCs ),
	atom_codes( DirNamePrv, DirNameCs ),
	unique_filename( DirNamePrv, DirNameNoSl ),
	atom_concat( DirNameNoSl, '/', DirName ),
	make_directory( DirName ).

store_one_iteration( DirCs, Samples, Iter, Mean, S2 ) :-
	number_codes( Samples, S ),
	number_codes( Iter, I ),
	flatten( [DirCs,"s_",S,"_i_",I], FnameCs ),
	atom_codes( Fname, FnameCs ),
	open( Fname, write, Stream ),
	write( Stream, Mean ),
	write( Stream, '  ' ),
	write( Stream, S2 ),
	nl( Stream ),
	close( Stream ).

store_iters_rtms( Dir, Its, RTms, Id ) :-
	append( Dir, "iterations", ItsFile ),
	append( Dir, "runtime", RtmFile ),
	term_to_file_cs( its(Id-Its), ItsFile ),
	term_to_file_cs( rtms(Id-RTms), RtmFile ).

term_to_file_cs( Term, FileCs ) :-
	atom_codes( File, FileCs ),
	open( File, append, S ),
	write_term( S, Term, [quoted(true)] ),
	write( S, '.' ),
	nl( S ),
	close( S ).

