:- ensure_loaded( '../src/lib/select_preferred' ).
:- ensure_loaded( '../src/lib/directory_contents' ).
:- ensure_loaded( '../src/lib/append_terms_to_file' ).
:- ensure_loaded( '../src/lib/read_matching_term_parts' ).
:- ensure_loaded( '../src/lib/mean_and_emp_std_dev_list' ).

% for example
% cd red_a ; upsh ../../../../helpers/sec.pl file_type=predictive
% 
sec( Opts ) :-
	sec_defaults( Defs ),
	select_preferred( repo(Rep), Opts, Defs ),
	select_preferred( file_type(TpFile), Opts, Defs ),
	directory_contents( '.', _Files, Dirs, _Other ),
	sec_dirs_to_terms( Dirs, TpFile, Terms ),
	append_terms_to_file( Rep, Terms ).

sec_defaults( [repo('repo.pl'),file_type(rmse_mean_sdv)] ).
	
sec_dirs_to_terms( [], _TpFile, [] ).
sec_dirs_to_terms( [H|T], TpFile, [HTerm|TTerms] ) :-
	file_to_terms( TpFile, H, HTerm ),
	sec_dirs_to_terms( T, TpFile, TTerms ).
	
file_to_terms( rmse_mean_sdv, Dir, Term ) :-
	!,
	atom_concat( Dir, '/', DirSl ),
	atom_concat( DirSl, rmse_mean_sdv, Rmse ),
	assert( mean_sdv(null,null,null) ),
	abolish( mean_sdv/3 ),
	read_matching_term_parts( Rmse, mean_sdv(A,B,C), A-B-C, Trips ),
	% findall( Sample-Mean-Sdv, mean_sdv(Sample,Mean,Sdv), Trips ),
	Term = stats( Dir, Trips ).
file_to_terms( predictive, Dir, Term ) :-
	!,
	atom_concat( Dir, '/', DirSl ),
	atom_concat( DirSl, predictive_rms_mean_n_sdv, Rmse ),
	assert( mean_sdv(null,null,null) ),
	abolish( mean_sdv/3 ),
	read_matching_term_parts( Rmse, mean_sdv(A,B,C), A-B-C, Trips ),
	Term = stats( Dir, Trips ).

file_to_terms( File, Dir, Term ) :-
	( (File==iterations,Match=its(S,VList))
	  ; (File==runtime,Match=rtms(S,VList)) ),
	atom_concat( Dir, '/', DirSl ),
	atom_concat( DirSl, File, Runtime ),
	assert( rtms(null,null) ),
	abolish( rtms/2 ),
	% consult( Runtime ),
	read_matching_term_parts( Runtime, Match, S-VList, Pairs ),
	% findall( Sample-Mean-Sdv, 
		% ( rtms(Sample,ValuesList),
	runtimes_pairs_msdv( Pairs, Trips ),
		  % ),
		  % Trips ),
	Term = stats( Dir, Trips ).

runtimes_pairs_msdv( [], [] ).
runtimes_pairs_msdv( [S-VList|T], [S-Mean-Sdv|TTrips] ) :-
	mean_and_emp_std_dev_list( VList, Mean, Sdv ),
	runtimes_pairs_msdv( T, TTrips ).
