:- ensure_loaded( mean_list ).					% /2.
:- ensure_loaded( library(lists) ).				% sum_list/2 .

% mean_and_emp_std_dev_list( [0.2,0.3,0.12,0.31,0.11], M, S ).
mean_and_emp_std_dev_list( List, Mean, S2 ) :-
	( var(Mean) ->
		mean_list( List, Mean )
		;
		true
	),
	length( List, N ),
	sum_list( List, Sum ),
	sum_of_squares( List, 0, SofSq ),
	S2 is sqrt( ((N * SofSq) - (Sum ** 2)) / (N * (N-1)) ).

sum_of_squares( [], SofSq, SofSq ).
sum_of_squares( [H|T], Acc, SofSq ) :-
	NxAcc is Acc + H ** 2,
	sum_of_squares( T, NxAcc, SofSq ).
