:- ensure_loaded( mean_list ).	% /2.

mean_and_std_dev_list( List, Mean, StDev ) :-
	( var(Mean) ->
		mean_list( List, Mean )
		;
		true
	),
	sum_of_square_diffs( List, Mean, SumOf ),
	length( List, N ),
	StDev is sqrt( SumOf / N ).

sum_of_square_diffs( [H|T], Mean, SumOf ) :-
	sum_of_square_diffs( [H|T], Mean, 0, SumOf ).
	
sum_of_square_diffs( [], _Mean, SumOf, SumOf ).
sum_of_square_diffs( [H|T], Mean, Acc, SumOf ) :-
	NwAcc is Acc + exp(H-Mean,2),
	sum_of_square_diffs( T, Mean, NwAcc, SumOf ).
