% :- ensure_loaded( '../../../pe/src/lib/experiment' ).
% :- ensure_loaded( '../../../pe/src/sload' ).
:- ensure_loaded( '../../../pe/pe' ).
:- ensure_loaded( delete_file_if ).

sample_that_many( Sload, Many, Goal, Freq ) :-
	sample_that_many_1( Sload, Many, Goal, Results ),
	list_frequency( Results, Freq ).

sample_that_many_1( Sload, Many, Goal, Clean ) :-
	sload( Sload ),
	% write_hr, nl, write( 'Loaded Slp: ' ),
	% write_hr, nl, sls, write_hr, nl,
	sample_many( 	Goal,
				Many,
				Products,
				0,
				Products,
				% '/dev/null',
				'.foofoutos',
				overwrite, 
				Results ),
	% write( experiments_ ),
	delete_file_if( '.foofoutos' ),
	clean_scall_results( Results, Clean ).

clean_scall_results( [], [] ).
clean_scall_results( [H|T], [Hc|Tc] ) :-
	H = scall( Hc, _Eps,_Sam,_Path,_Succ,_Prb ),
	clean_scall_results( T, Tc ).

sample_many( Goal, Tms, Obs,  Eps, Wrtbl, File, FMode, Results ) :-
	experiment( [
		times( Tms ),
		clause( scall( Goal, Eps, sample, _P, true, _R ), Wrtbl ),
		file( File ), filemode( FMode ),
		observables( Obs ), count_failures(no),
		rand(false)
		], 
		Results ).
