:- ensure_loaded( library(system) ).		% datime/1, host_name/1.
:- ensure_loaded( datime_to_readable ).		% /2.
:- ensure_loaded( library(random) ).		% getrand/1.

start_billow_recording( Dir, Slp, Info, Exprs, Opts, Stream, Out, Err ) :-
	current_output( Out ),
	current_prolog_flag( user_error, Err ),
	atom_concat( Dir, '/', DirSl ),
	atom_concat( DirSl, Info, File ),
	open( File, write, Stream ),
	set_output( Stream ),
	set_prolog_flag( user_error, Stream ),
	write( 'Generated by Billow (' ),
	bb_get( billow_version, Vers ),
	write( Vers ), write( ').' ), nl,
	datime( Datime ),
	datime_to_readable( Datime, ReadableCs ),
	atom_codes( Readable, ReadableCs ),
	write( Readable ), nl,
	write_hr, nl,
	write( 'To run experiments:' ), nl,
	write_experiments( Exprs ), nl,
	getrand( Seeds ),
	write( seeds(Seeds) ), nl,
	write_hr, nl,
	host_name( Host ),
	write( 'On machine: ' ), write( Host ), nl,
	working_directory( Cur, Cur ),
	write( 'Called from directory: ' ), write( Cur ), nl,
	write( 'Complete call was billow(' ), write( Opts ), write( ').'), nl,
	slp_file_location( Slp, SlpFile ),
	write( 'Slp: '  ), write( SlpFile ), nl,
	write_hr, nl,
	atoms_concat( ['cp ', SlpFile, ' ', Dir], Cp ),
	system( Cp ).

write_experiments( [] ).
write_experiments( [expr_data(Id,Runs,Dims,Dirs)|T] ) :-
	write( '     Id: ' ), write( Id ), nl,
	write( '          runs: ' ), write( Runs ), nl,
	write( '          dims: ' ), write( Dims ), nl,
	write( '          dirs: ' ), write( Dirs ), nl, nl,
	write_experiments( T ).

write_hr :-
	write( '----------------------------' ), nl.
