:- ensure_loaded( library(system) ).  % working_directory/2, system/1.

plot_multi_trips( MultiTrips, Dir, Xxr/Yxr, Titles ) :-
	multi_trips_to_datafiles( MultiTrips, Titles, Dir, DataFiles ),
	atom_concat( Dir, gnu_com_file, GnuComsRel ),
	absolute_file_name( GnuComsRel, GnuComs ),
	open( GnuComs, write, Stream ),
	write( Stream, 'set multiplot' ), nl( Stream ),
	write( Stream, 'set xrange [0:' ),
	write( Stream, Xxr ), write( Stream, ']' ), nl( Stream ),
	write( Stream, 'set yrange [0:' ),
	write( Stream, Yxr ), write( Stream, ']' ), nl( Stream ),
	write( Stream, 'plot ' ),
	datafiles_to_plot_commands( DataFiles, Titles, Stream ),
	close( Stream ),
	atom_concat( Dir, gnu_com_file_col, GnuColRel ),
	absolute_file_name( GnuColRel, GnuCol ),
	atom_concat( Dir, gnu_com_file_mono, GnuMonoRel ),
	absolute_file_name( GnuMonoRel, GnuMono ),
	working_directory( OldDir, Dir ),
	write( datafiles(DataFiles) ), nl,
	write( gnufile(gnu_com_file) ), nl,
	% atom_concat( Dir, gnu_com_file_col, GnuCol ),
	set_gnu_eps_file_output( GnuComs, Dir, colour, GnuCol ),
	system( 'gnuplot \"gnu_com_file_col\"'),
	% atom_concat( Dir, gnu_com_file_mono, GnuMono ),
	set_gnu_eps_file_output( GnuComs, Dir, mono, GnuMono ),
	system( 'gnuplot -mono \"gnu_com_file_mono\"'),
	working_directory( _DirAg, OldDir ).
	% atom_concat( 'mv gnu_com_file* ',Dir, Mv ),
	% system( Mv ).

multi_trips_to_datafiles( [], _Empty, _DirSl, [] ).
multi_trips_to_datafiles( [H|T], [Httl|TTtl], DirSl, [Hdat|Tdf] ) :-
	datafile_name( DirSl, Httl, Hdf, Hdat ),
	trips_to_datafile( Hdf, H ),
	multi_trips_to_datafiles( T, TTtl, DirSl, Tdf ).

datafile_name( DirSl, FName, Dfln, Dat ) :-
	( file_exists( DirSl ) -> 
		true
		;
		make_directory( DirSl )
	),
	atom_concat( FName, '.dat', Dat ),
	atom_concat( DirSl, Dat, Dfln ).

trips_to_datafile( File, Trips ) :-
	open( File, write, Stream ), 
	trips_to_stream( Trips, Stream ),
	close( Stream ).

trips_to_stream( [], _Stream ).
trips_to_stream( [X-Y-Yd|T], Stream ) :-
	write( Stream, X ), write( Stream, ' ' ), 
	write( Stream, Y ), write( Stream, ' ' ),
	write( Stream, Yd), nl( Stream ),
	trips_to_stream( T, Stream ).

datafiles_to_plot_commands( [], _Empty, _Stream ).
datafiles_to_plot_commands( [H|T], [Hti|Tti], Stream ) :-
	%  write( Stream, Hti ),
	write( Stream, ' \"' ), write( Stream, H ), 
	write( Stream, '\" using 1:2 ' ),
		write( Stream, ' title \"' ),
		write( Stream, Hti ), 
		write( Stream, '\"' ),
		write( Stream, ' with lines, ' ),
	write( Stream, '"' ), write( Stream, H ), 
	write( Stream, '\" notitle with yerrorbars' ),
	( T = [] ->
		true
		;
		write( Stream, ',' )
	),
	datafiles_to_plot_commands( T, Tti, Stream ).

set_gnu_eps_file_output( SkelCF, _BaseDirSl, ColOr, FullCF ) :-
	% atom_concat( BaseDirSl, FullCF, ExtF ),
	% write( user_error, fullcf(FullCF) ), nl( user_error ),
	open( FullCF, write, Wstream ),
	write( Wstream, 'set terminal postscript eps ' ),
	write( Wstream, ColOr ), nl( Wstream ),
	write( Wstream, 'set output \"' ),
	% write( Wstream, BaseDirSl ), % write( Wstream, '/' ),
	write( Wstream, ColOr ), write( Wstream, '.eps' ),
	write( Wstream, '\"' ),
	nl( Wstream ),
	close( Wstream ),
	atom_concat( 'cat ', SkelCF, Pfx1 ),
	atom_concat( Pfx1, ' >> ', Pfx2 ),
	atom_concat( Pfx2, FullCF, Cat ),
	system( Cat ).
